%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%endif

%if ! (0%{?fedora} > 16)
%{!?ruby_vendorarchdir: %global ruby_vendorarchdir %(ruby -rrbconfig -e 'puts Config::CONFIG["vendorarchdir"] ')}
%endif

# whether to build with PCRE or ICU (default = PCRE)
# %%global _with_icu 1

Name:			manatee-open
Version:		2.59.1
Release:		1%{?dist}
Summary:		Corpus management and query system

Group:			Applications/Databases
License:		GPLv2+
URL:			http://nlp.fi.muni.cz/trac/noske/
Source0:		http://corpora.fi.muni.cz/noske//src/manatee-open/%{name}-%{version}.tar.gz
Source1:		http://corpora.fi.muni.cz/noske//src/example-corpora/susanne-example-source.tar.bz2
BuildRoot:		%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:		gcc-c++
BuildRequires:		python-devel
BuildRequires:		perl-devel
BuildRequires:		libgcj-devel
BuildRequires:		finlib-devel >= 2.17
BuildRequires:		antlr3-C-devel >= 3.2
BuildRequires:		ruby-devel
BuildRequires:		libtool-ltdl-devel
%if %{?_with_icu:1}%{!?_with_icu:0}
BuildRequires:		libicu-devel
%else
BuildRequires:		pcre-devel
%endif

%description
Manatee is a corpus management and query system.

%package python
Summary:	Python bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Group:		Applications/Databases

%description python
This package contains Python bindings for Manatee which are necessary if you
want to use Manatee from Python environment.

%package perl
Summary:	Perl bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Group:		Applications/Databases

%description perl
This package contains Perl bindings for Manatee which are necessary if you
want to use Manatee from Perl environment.

%package ruby
Summary:	Ruby bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Requires:	ruby(abi) = 1.8
Group:		Applications/Databases

%description ruby
This package contains Ruby bindings for Manatee which are necessary if you
want to use Manatee from Ruby environment.

%package java
Summary:	Java bindings for Manatee
Requires:	%{name} = %{version}-%{release}
Group:		Applications/Databases

%description java
This package contains Java JNI bindings for Manatee which are necessary if you
want to use Manatee from Java environment.

%package devel
Summary:	Development files for %{name}
Group:		Development/Libraries

Requires:   %{name} = %{version}-%{release}

%description devel
This package contains development files for %{name}.

%package static
Summary:	Manatee static libaries
Group:		Development/Libraries

Requires:   %{name}-devel = %{version}-%{release}

%description static
This package contains Manatee static libraries.

%package susanne
Summary:	Example Manatee corpus SUSANNE %{name}
Group:		Applications/Databases

Requires:   %{name} = %{version}-%{release}

%description susanne
This package contains example corpus SUSANNE encoded for Manatee.

%prep
%setup -q
%setup -q -T -D -a 1

%build
export RPM_OPT_FLAGS="$RPM_OPT_FLAGS -lltdl"
export CFLAGS="$RPM_OPT_FLAGS -lltdl"
export CXXFLAGS="$RPM_OPT_FLAGS -lltdl"

# don't use internal libltdl
rm -rf libltdl
sed -i 's|LIBLTDL=.*|LIBLTDL=|' configure 
sed -i 's|SUBDIRS = $(FINLIB_SUBDIRS) libltdl|SUBDIRS = $(FINLIB_SUBDIRS)|' Makefile.in

%if %{?_with_icu:1}%{!?_with_icu:0}
	%configure  --enable-cxxlib --with-gnu-ld --with-icu --enable-ltdl-install=no
%else
	%configure  --enable-cxxlib --with-gnu-ld --with-pcre --enable-ltdl-install=no
%endif

# remove rpaths
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%global manatee_dir %{_sharedstatedir}/manatee
export MANATEE_REGISTRY=%{manatee_dir}/registry
make #%{?_smp_mflags} does not work

# encode example SUSANNE corpus
src/encodevert -c ./susanne-example-source/config susanne-example-source/source

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
find $RPM_BUILD_ROOT -name *.la -delete

# install SUSANNE corpus
mkdir -p $RPM_BUILD_ROOT%{manatee_dir}/{data,vert,registry}
sed -i -e 's|PATH.*|PATH "%{manatee_dir}/data/susanne"|' -e 's|VERTICAL.*|VERTICAL "%{manatee_dir}/vert/susanne.vert"|' susanne-example-source/config
cp -p susanne-example-source/config $RPM_BUILD_ROOT%{manatee_dir}/registry/susanne
cp -rp susanne $RPM_BUILD_ROOT%{manatee_dir}/data/
cp -p susanne-example-source/source $RPM_BUILD_ROOT%{manatee_dir}/vert/susanne.vert

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc AUTHORS README ChangeLog
%docdir doc
%{_bindir}/corpinfo
%{_bindir}/encodevert
%{_bindir}/lscbgr
%{_bindir}/lsclex
%{_bindir}/manateesrv
%{_bindir}/mkdynattr
%{_bindir}/mknorms
%{_bindir}/mkvirt
%{_libdir}/libmanatee.so.*
%dir %{manatee_dir}/data
%dir %{manatee_dir}/vert
%dir %{manatee_dir}/registry

%files python
%defattr(-,root,root,-)
%{_bindir}/addwcattr
%{_bindir}/concinfo
%{_bindir}/corpquery
%{_bindir}/decodevert
%{_bindir}/freqs
%{_bindir}/lslexarf
%{_bindir}/lsslex
%{_bindir}/mksubc
%{_bindir}/compilecorp
%{python_sitearch}/*

%files java
%defattr(-,root,root,-)
%{_libdir}/manatee/
%doc api/example.java

%files perl
%defattr(-,root,root,-)
%{perl_vendorarch}/*
%doc api/corpquery.pl

%files ruby
%defattr(-,root,root,-)
%{ruby_vendorarchdir}/*

%files devel
%defattr(-,root,root,-)
%{_includedir}/manatee/
%{_libdir}/*.so

%files static
%defattr(-,root,root,-)
%{_libdir}/*.a

%files susanne
%defattr(-,root,root,-)
%{manatee_dir}/data/susanne/
%{manatee_dir}/vert/susanne.vert
%{manatee_dir}/registry/susanne

%changelog
* Tue Oct 23 2012 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.59.1-1
- Update to 2.59.1

* Mon Feb 28 2011 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.33.2-1
- Update to 2.33.2

* Thu Jan 20 2011 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.33.1-1
- Update to 2.33.1, add susanne subpackage

* Mon Dec 06 2010 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.32.2-1
- Update to 2.32.2

* Sun Oct 31 2010 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.32.1-1
- Update to 2.32.1

* Wed Oct 27 2010 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.32-1
- Update to 2.32, build from distribution tarball
- Remove BR: antlr3-tool, swig

* Fri Aug 27 2010 Miloš Jakubíček <xjakub@fi.muni.cz> - 2.31.3-1
- Update to 2.31.3 (fix multivalue attr freq dist)

* Fri Apr 23 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.31-1
- Update to 2.31 (support for nested structures)

* Fri Apr 16 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.30-1
- Update to 2.30
- Fix installing ruby and perl API's according to changes in 2.30
- Fix installing manatee.so as part of Perl API => not noarch anymore

* Fri Apr 09 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.29.1-1
- Update to 2.29.1
- Compilecorp included to manatee

* Sun Feb 14 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.28-1
- Update to 2.28
- Fix installing manatee-python into python_sitearch, not python_sitelib
  (it's arch-dependent)
- Move python scripts in %%{_bindir} into the python-subpackage

* Mon Feb 01 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.28-0.2.ANTLR3.EXPERIMENTAL
- Antlr3 improved support

* Thu Jan 21 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.28-0.1.ANTLR3.EXPERIMENTAL
- Antlr3 experimental support
- Support for "<query> within <query>"
- Support for "contains" as dual option to "within"

* Thu Jan 14 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.27-1
- Update to 2.27
- Dropped all ruby, java and API patches (merged upstream)
- Make Perl API example a doc

* Mon Jan 08 2010 Milos Jakubicek <xjakub@fi.muni.cz> - 2.26-2
- Dropped antlr patch (merged into git).
- Use XZ sources
- Patch to enable ruby bindings
- Patch to do not conflict with java-1.6.0-openjdk-devel
- Patch to install all Python and Perl API scripts
- Minor package sanity (do not include java files into -devel subpackage)
- Call ldconfig properly

* Thu Dec 17 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.26-1
- Update to 2.26
- Reintroduce patch for antlr >= 2.7.2
- Temporarily disable BR: java-1.6.0-openjdk-devel since it
  conflicts with libgcj-devel

* Thu Oct 29 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.25-1
- Update to 2.25
- Fixed closing of *.rng files 
- Fixed structures ordering
- Fixed unifying of structures invervals in subcorpora

* Thu Sep 24 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.24-1
- Update to 2.24
- Update BR: finlib-devel >= 2.07

* Mon Jul 27 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.22-3
- Sync with latest 2.22.
- Fix another ANTLR >= 2.7.2 AST issue.

* Wed Jul 01 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.22-2
- Split into -devel subpackage.
- Added BR: swig, java-devel

* Sat Jun 27 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.22-1
- Update to 2.22
- All patches merged.
- Antlr autodetection.
- Split python, perl and java bindings into subpackages.

* Mon Jun 22 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.21-1
- Update to 2.21
- Use separate finlib, antlr => added BR finlib >= 2.06, antlr < 3

* Sun Jun 21 2009 Milos Jakubicek <xjakub@fi.muni.cz> - 2.16-1
- Patch for gcc 4.4

* Tue Aug 05 2008 Milos Jakubicek <xjakub@fi.muni.cz> - 2.16-1
- Initial release.
- Patched to build with gcc 4.3
- Tried to patch to build with current antlr, but seems to much work for now.
- Patched to use system's libltdl instead of its own.
- Patched to make the supplied antlr build with gcc 4.3
